'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createFirebaseInstance = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _actions = require('./actions');

var createFirebaseInstance = exports.createFirebaseInstance = function createFirebaseInstance(firebase, configs, dispatch) {
  var defaultInternals = { watchers: {}, config: configs, authUid: null };
  Object.defineProperty(firebase, '_', {
    value: defaultInternals,
    writable: true,
    enumerable: true,
    configurable: true
  });

  var get = function get(collection, doc, opts) {
    return _actions.firestoreActions.get(firebase, dispatch, collection, doc, opts);
  };

  var set = function set(collection, doc, opts) {
    return _actions.firestoreActions.set(firebase, dispatch, collection, doc, opts);
  };

  var add = function add(collection, doc, opts) {
    return _actions.firestoreActions.add(firebase, dispatch, collection, doc, opts);
  };

  var onSnapshot = function onSnapshot(collection, doc, opts) {
    return _actions.firestoreActions.onSnapshot(firebase, dispatch, collection, doc, opts);
  };

  return _extends({
    get: get,
    add: add,
    set: set,
    onSnapshot: onSnapshot
  }, firebase);
};

exports.default = createFirebaseInstance;